Index: pjproject/trunk/pjmedia/src/pjmedia-codec/g722/g722_enc.h
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/g722/g722_enc.h	(revision 1870)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/g722/g722_enc.h	(revision 1870)
@@ -0,0 +1,77 @@
+/* $Id$ */
+/* 
+ * Copyright (C)2003-2008 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+/*
+ * Based on implementation found in Carnegie Mellon Speech Group Software
+ * depository (ftp://ftp.cs.cmu.edu/project/fgdata/index.html). No copyright
+ * was claimed in the original source codes.
+ */
+#ifndef __PJMEDIA_CODEC_G722_ENC_H__
+#define __PJMEDIA_CODEC_G722_ENC_H__
+
+#include <pjmedia-codec/types.h>
+
+/* Encoder state */
+typedef struct g722_enc_t {
+    /* PCM low band */
+    int slow;
+    int detlow;
+    int spl;
+    int szl;
+    int rlt  [3];
+    int al   [3];
+    int apl  [3];
+    int plt  [3];
+    int dlt  [7];
+    int bl   [7];
+    int bpl  [7];
+    int sgl  [7];
+    int nbl;
+
+    /* PCM high band*/
+    int shigh;
+    int dethigh;
+    int sph;
+    int szh;
+    int rh   [3];
+    int ah   [3];
+    int aph  [3];
+    int ph   [3];
+    int dh   [7];
+    int bh   [7];
+    int bph  [7];
+    int sgh  [7];
+    int nbh;
+
+    /* QMF signal history */
+    int x[24];
+} g722_enc_t;
+
+
+PJ_DECL(pj_status_t) g722_enc_init(g722_enc_t *enc);
+
+PJ_DECL(pj_status_t) g722_enc_encode(g722_enc_t *enc, 
+				     pj_int16_t in[], 
+				     pj_size_t nsamples,
+				     void *out,
+				     pj_size_t *out_size);
+
+PJ_DECL(pj_status_t) g722_enc_deinit(g722_enc_t *enc);
+
+#endif /* __PJMEDIA_CODEC_G722_ENC_H__ */
+
Index: pjproject/trunk/pjsip-apps/src/samples/encdec.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/encdec.c	(revision 1869)
+++ pjproject/trunk/pjsip-apps/src/samples/encdec.c	(revision 1870)
@@ -267,4 +267,7 @@
     CHECK( keystream_g729ab_init(mept) );
 #endif
+#if PJMEDIA_HAS_G722_CODEC
+    CHECK( pjmedia_codec_g722_init(mept) );
+#endif
 
     pj_gettimeofday(&t0);
Index: pjproject/trunk/pjsip-apps/src/samples/pcaputil.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/pcaputil.c	(revision 1869)
+++ pjproject/trunk/pjsip-apps/src/samples/pcaputil.c	(revision 1870)
@@ -244,4 +244,8 @@
 #endif	/* PJMEDIA_HAS_G711_CODEC */
 
+#if PJMEDIA_HAS_G722_CODEC
+    T( pjmedia_codec_g722_init(app.mept) );
+#endif	/* PJMEDIA_HAS_G722_CODEC */
+
 #if PJMEDIA_HAS_L16_CODEC
     T( pjmedia_codec_l16_init(app.mept, 0) );
Index: pjproject/trunk/pjsip-apps/src/samples/pjsip-perf.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/pjsip-perf.c	(revision 1869)
+++ pjproject/trunk/pjsip-apps/src/samples/pjsip-perf.c	(revision 1870)
@@ -936,4 +936,7 @@
 #if defined(PJMEDIA_HAS_SPEEX_CODEC) && PJMEDIA_HAS_SPEEX_CODEC!=0
     pjmedia_codec_speex_init(app.med_endpt, PJMEDIA_SPEEX_NO_UWB, 3, 3);
+#endif
+#if defined(PJMEDIA_HAS_G722_CODEC) && PJMEDIA_HAS_G722_CODEC!=0
+    pjmedia_codec_g722_init(app.med_endpt);
 #endif
 
Index: pjproject/trunk/pjsip-apps/src/samples/streamutil.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/streamutil.c	(revision 1869)
+++ pjproject/trunk/pjsip-apps/src/samples/streamutil.c	(revision 1870)
@@ -116,4 +116,9 @@
 #if defined(PJMEDIA_HAS_SPEEX_CODEC) && PJMEDIA_HAS_SPEEX_CODEC!=0
     status = pjmedia_codec_speex_init(med_endpt, 0, -1, -1);
+    PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
+#endif
+
+#if defined(PJMEDIA_HAS_G722_CODEC) && PJMEDIA_HAS_G722_CODEC!=0
+    status = pjmedia_codec_g722_init(med_endpt);
     PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
 #endif
Index: pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 1869)
+++ pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 1870)
@@ -140,4 +140,13 @@
 #endif	/* PJMEDIA_HAS_G711_CODEC */
 
+#if PJMEDIA_HAS_G722_CODEC
+    status = pjmedia_codec_g722_init( pjsua_var.med_endpt );
+    if (status != PJ_SUCCESS) {
+	pjsua_perror(THIS_FILE, "Error initializing G722 codec",
+		     status);
+	return status;
+    }
+#endif  /* PJMEDIA_HAS_G722_CODEC */
+
 #if PJMEDIA_HAS_L16_CODEC
     /* Register L16 family codecs, but disable all */
@@ -501,8 +510,11 @@
 #	endif	/* PJMEDIA_HAS_G711_CODEC */
 
+#	if PJMEDIA_HAS_G722_CODEC
+	    pjmedia_codec_g722_deinit();
+#	endif	/* PJMEDIA_HAS_G722_CODEC */
+
 #	if PJMEDIA_HAS_L16_CODEC
 	    pjmedia_codec_l16_deinit();
 #	endif	/* PJMEDIA_HAS_L16_CODEC */
-
 
 	pjmedia_endpt_destroy(pjsua_var.med_endpt);
